//+------------------------------------------------------------------+
//|                                      QQE_EA.mq4                  |
//|                                      Copyright Jasius 2008       |
//|                                      jasius_1@yahoo.com          |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Jasius."
#property link      "jasius_1@yahoo.com"


extern double TakeProfit = 1000;
extern double Lots = 0.01;
extern double TrailingStop = 400;
//extern double fastQQEparm=5;
//extern double slowQQEparm=50;
double Points;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init ()
  {
   Points = MarketInfo (Symbol(), MODE_POINT);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int cnt=0, total;
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  
     }
//   double fastQQE1 = iCustom(NULL,0,"QQEA",fastQQEparm,14,4.236,0,1);
//   double fastQQE2 = iCustom(NULL,0,"QQEA",fastQQEparm,14,4.236,1,1);
   double Solid0 = iCustom(NULL,0,"QQEA",0,0);
   double Solid1 = iCustom(NULL,0,"QQEA",0,1);

   double Dotted0 = iCustom(NULL,0,"QQEA",1,0);
   double Dotted1 = iCustom(NULL,0,"QQEA",1,1);   
   double psar0   = iSAR(NULL,0,0.02,0.2,0);  
   double psar1   = iSAR(NULL,0,0.02,0.2,1);     
   
   
   if(OrdersTotal()<3) 
     {
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money");
         return(0);  
        }
      if(Dotted1 > Solid1 && Solid0 > Dotted0 && psar0 < Close[0])
        {
         OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Points,"macd sample",16384,0,Red); 
         if(GetLastError()==0)Print("Order opened : ",OrderOpenPrice());
         return(0);
        }
      if(Solid1 > Dotted1 && Dotted0 > Solid0 && psar0 > Close[0])
        {
         OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Points,"macd sample",16384,0,Red); 
         if(GetLastError()==0)Print("Order opened : ",OrderOpenPrice());
         return(0); 
        }
      return(0);
     }
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && 
         OrderSymbol()==Symbol())   
        {
         if(OrderType()==OP_BUY)   
           {
            if(psar0 >Close[0])
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); 
                 return(0); 
                }
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Points*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Points*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Points*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
         else
           {
             if(psar0 < Close[0])
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); 
               return(0);
              }
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Points*TrailingStop))
                 {
                  if(OrderStopLoss()==0.0 || 
                     OrderStopLoss()>(Ask+Points*TrailingStop))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Points*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.